﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.3
@EndOfDesignText@
#if B4A
'ignore DIP related warnings as they are not relevant when working with BitmapCreator
#IgnoreWarnings: 6
#end if
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
Sub Class_Globals
	Public X2 As X2Utils
	Private xui As XUI 'ignore
	Public world As B2World
	Public Ground As X2BodyWrapper
	Private ivForeground As B4XView
	Private ivBackground As B4XView
	Public lblStats As B4XView
	Public TileMap As X2TileMap
	Private MiniTileMap As X2TileMap
	Private pnlMiniMap As B4XView
	Public RightDown, LeftDown,  DownDown As Boolean
	Public JumpDown As Boolean
	Private pnlTouch As B4XView 'ignore
	Private ivMiniMap As ImageView
	Private ivMiniMapBC As BitmapCreator
	Private MiniMapScreenWindow As CompressedBC
	Public Const ObjectLayerName As String = "Objektebene 1"
	Public myLayers As List
	Private mMario As Mario
	Private LeftEdge As X2BodyWrapper
	
	
	
	Private GameOverState As Boolean
	Type EnemyTemplates (Template As X2TileObjectTemplate, XPosition As Float)
	Private EnemyTemplates As List

End Sub

Public Sub Initialize (Parent As B4XView)
	Parent.LoadLayout("1")
	world.Initialize("world", world.CreateVec2(0, -10))
	X2.Initialize(Me, ivForeground, world)
'	Configure the dimensions.
'	X2.ConfigureDimensions(world.CreateVec2(10, 10),  10)
	Dim WorldHeight As Float = 14 'the size of each tile will be approximately 1x1 meter
	Dim WorldWidth As Float = WorldHeight * 1.3333	
	
	X2.ConfigureDimensions(world.CreateVec2(WorldWidth / 1, WorldHeight / 1),  WorldWidth)
	TileMap.Initialize(X2, File.DirAssets, "Mystery Forest.json", ivBackground)
	TileMap.SetSingleTileDimensionsInMeters(0.5, 0.5)
	
	lblStats.TextColor = xui.Color_Green
	'comment to disable debug drawing
'	X2.EnableDebugDraw
	CreateMiniMap
		
	TileMap.PrepareObjectsDef(ObjectLayerName)

'	'create all other objects
	Dim layer As X2ObjectsLayer = TileMap.Layers.Get(ObjectLayerName)
	For Each template As X2TileObjectTemplate In layer.ObjectsById.Values
		TileMap.CreateObject(template)
	Next

'	ivMiniMapBC.Initialize(ivMiniMap.Width / xui.Scale, ivMiniMap.Height / xui.Scale)
	LoadMarioGraphics
End Sub

Private Sub LoadMarioGraphics
	Dim bmp As B4XBitmap = xui.LoadBitmap(File.DirAssets, "mario_bros.png")
	Dim NumberOfSprites As Int = 14
	Dim MarioSmall As B4XBitmap = bmp.Crop(80, 32, NumberOfSprites * 16, 16)
	Dim AllSmall As List = X2.ReadSprites(MarioSmall, 1, NumberOfSprites, 1, 1)
	X2.GraphicCache.PutGraphic("mario small walking", Array(AllSmall.Get(0), AllSmall.Get(1), AllSmall.Get(2)))
	X2.GraphicCache.PutGraphic("mario small standing", Array(AllSmall.Get(6)))
	X2.GraphicCache.PutGraphic("mario small jumping", Array(AllSmall.Get(4)))
	X2.GraphicCache.PutGraphic("mario small strike", Array(AllSmall.Get(5)))
	X2.GraphicCache.PutGraphic("mario small change direction", Array(AllSmall.Get(3)))
	NumberOfSprites = 19
	Dim MarioLarge As B4XBitmap = bmp.Crop(80, 0, NumberOfSprites * 16, 32)
	Dim AllLarge As List = X2.ReadSprites(MarioLarge, 1, NumberOfSprites, 1, 2)
	X2.GraphicCache.PutGraphic("mario large walking", Array(AllLarge.Get(0), AllLarge.Get(1), AllLarge.Get(2)))
	X2.GraphicCache.PutGraphic("mario large standing", Array(AllLarge.Get(6)))
	X2.GraphicCache.PutGraphic("mario large jumping", Array(AllLarge.Get(4)))
	X2.GraphicCache.PutGraphic("mario large strike", Array(AllLarge.Get(5)))
	X2.GraphicCache.PutGraphic("mario large change direction", Array(AllLarge.Get(3)))
	
	X2.GraphicCache.PutGraphic("mario change size", Array(AllSmall.Get(6), AllLarge.Get(6)))
End Sub

Public Sub StartGame
	If X2.IsRunning Then Return
	X2.Reset
	X2.UpdateWorldCenter(X2.CreateVec2(X2.ScreenAABB.Width / 2, X2.ScreenAABB.Height / 2))
	GameOverState = False
	'music file removed to reduce the examples pack size.
	'X2.SoundPool.PlayMusic(File.DirAssets, "main_theme.mp3")
	TileMap.Initialize(X2, File.DirAssets, "Mystery Forest.json", ivBackground)
	Dim TileSizeMeters As Float = X2.ScreenAABB.Height / TileMap.TilesPerColumn
	TileMap.SetSingleTileDimensionsInMeters(TileSizeMeters, TileSizeMeters)
	TileMap.PrepareObjectsDef(ObjectLayerName)
	'
	' Hintergrundfarbe
'	TileMap.SetBackgroundColor(0xFF008AFF)
	TileMap.SetBackgroundColor(0xFF000000)
	'create mario
	Dim bw As X2BodyWrapper = TileMap.CreateObject(TileMap.GetObjectTemplate(ObjectLayerName,11)) '11 = mario id in the map
	bw.Body.LinearDamping = 1
	mMario.Initialize(bw)
	'
'	LeftEdge = TileMap.CreateObject(TileMap.GetObjectTemplate(ObjectLayerName, 22))
	' World-Dimentions in Meters
	Main.WorldEdges.Initialize 
	Main.WorldEdges.Bottom = 0.0
	Main.WorldEdges.Left = 0.0 
	Main.WorldEdges.Right = TileMap.TileWidthMeters * TileMap.TilesPerRow 
	Main.WorldEdges.Top = TileMap.TileHeightMeters * TileMap.TilesPerColumn 
	'
	'create all other objects
	Dim layer As X2ObjectsLayer = TileMap.Layers.Get(ObjectLayerName)
	EnemyTemplates.Initialize
	For Each template As X2TileObjectTemplate In layer.ObjectsById.Values
		If template.FirstTime And template.Name.Contains("template") = False Then
			If template.Name.Contains("enemy") Then
				'enemies are only created when they become visible
				Dim et As EnemyTemplates
				et.Template = template
				et.XPosition = template.Position.X
				EnemyTemplates.Add(et)
				Continue
			End If
			TileMap.CreateObject(template)
		End If
	Next
	EnemyTemplates.SortType("XPosition", True)
'	CreateEnemies
	X2.Start
End Sub

Public Sub StopGame
'	X2.SoundPool.StopMusic
	X2.Stop
End Sub

Public Sub GameOver
'	X2.SoundPool.StopMusic
'	X2.SoundPool.PlaySound("gameover")
	X2.AddFutureTask(Me, "Set_GameOver", 3500, Null)
End Sub

Private Sub Set_GameOver (ft As X2FutureTask)
	GameOverState = True
	Sleep(500)
	StartGame
End Sub

Private Sub CreateMiniMap

	'load the map
	MiniTileMap.Initialize(X2, File.DirAssets, "Mystery Forest.json", ivMiniMap)
	MiniTileMap.SetSingleTileDimensionsInBCPixels(ivMiniMap.Width / xui.Scale / MiniTileMap.TilesPerRow, ivMiniMap.Height / xui.Scale / MiniTileMap.TilesPerColumn)
	Dim tasks As List
	tasks.Initialize
	MiniTileMap.Draw(Array("Background"), MiniTileMap.MapAABB, tasks)
	'draw it synchronously to make the flow simpler
	For Each dt As DrawTask In tasks
		If dt.IsCompressedSource Then
			MiniTileMap.CurrentBC.DrawCompressedBitmap(dt.Source, dt.SrcRect, dt.TargetX, dt.TargetY)
		End If
	Next
	'create the yellow rectangle
	Dim scale As Float = MiniTileMap.TileWidthMeters / TileMap.TileWidthMeters * X2.mBCPixelsPerMeter
	Dim bc As BitmapCreator
	bc.Initialize(Ceil(X2.ScreenAABB.Width * scale) + 4, Ceil(X2.ScreenAABB.Height * scale) + 4)
	bc.FillRect(xui.Color_Yellow, bc.TargetRect)
	Dim r As B4XRect
	r.Initialize(2, 2, bc.mWidth - 2, bc.mHeight - 2)
	bc.FillRect(xui.Color_Transparent, r)
	MiniMapScreenWindow = bc.ExtractCompressedBC(bc.TargetRect, X2.GraphicCache.CBCCache)
	pnlTouch.Width =ivMiniMap.Width
	pnlTouch.Height =ivMiniMap.Height
End Sub
 
Private Sub DrawMiniMap (gs As X2GameStep)
	Dim scale As Float = MiniTileMap.TileWidthMeters / TileMap.TileWidthMeters * X2.mBCPixelsPerMeter
	Dim dt As DrawTask = ivMiniMapBC.CreateDrawTask(MiniTileMap.CurrentBC, MiniTileMap.CurrentBC.TargetRect, 0, 0, True)
	dt.TargetBC = ivMiniMapBC 'must set the target as it is not the the default one (MainBC)
	gs.DrawingTasks.Add(dt)
	Dim x As Int = X2.ScreenAABB.BottomLeft.X * scale
	Dim y As Int = X2.ScreenAABB.TopRight.Y * scale
	y = ivMiniMapBC.mHeight - y 'BC Y axis goes from the top to the bottom
	dt = ivMiniMapBC.CreateDrawTask(MiniMapScreenWindow, MiniMapScreenWindow.TargetRect, x - 2, y - 2, True)
	dt.IsCompressedSource = True
	dt.TargetBC = ivMiniMapBC 'must set the target as it is not the the default one (MainBC)
	gs.DrawingTasks.Add(dt)
End Sub

Private Sub pnlMiniMap_Touch (Action As Int, X As Float, Y As Float)
	If Action = pnlMiniMap.TOUCH_ACTION_MOVE_NOTOUCH Then Return
	Dim v As B2Vec2, sWert As Float
	'
	' Links und Rechts
	sWert = x / pnlMiniMap.Width '* scale
	If sWert > 0.83 Then
		v.X =TileMap.TilesPerRow * TileMap.TileWidthMeters * 0.83
	Else If sWert < 0.17 Then
		v.X =TileMap.TilesPerRow * TileMap.TileWidthMeters * 0.17
	Else
		v.X =TileMap.TilesPerRow * TileMap.TileWidthMeters * sWert
	End If
	'
	' Oben und Unten
	sWert = (pnlMiniMap.Height - Y) / pnlMiniMap.Height
	If sWert > 0.8 Then
		v.Y =TileMap.TilesPerColumn * TileMap.TileHeightMeters * 0.8
	Else If sWert < 0.20 Then
		v.Y =TileMap.TilesPerColumn * TileMap.TileHeightMeters * 0.20
	Else
		v.Y =TileMap.TilesPerColumn * TileMap.TileHeightMeters * sWert
	End If
'	v.X = x / pnlMiniMap.Width * TileMap.TilesPerRow * TileMap.TileWidthMeters
'	v.Y = (pnlMiniMap.Height - Y) / pnlMiniMap.Height * TileMap.TilesPerColumn * TileMap.TileHeightMeters
	X2.UpdateWorldCenter(v)
End Sub

Public Sub Resize
	X2.ImageViewResized
End Sub


''Return True to stop the game loop
'Public Sub BeforeTimeStep (GS As X2GameStep) As Boolean
'	Return False
'End Sub

Public Sub Tick (GS As X2GameStep)
'	HandleKeys (GS)
	mMario.Tick(GS)
	If TileMap.DrawScreen(Array("Background","Dinge","Walls"), X2.gs.DrawingTasks) Then
'		DrawMiniMap(GS)
	End If

End Sub


Public Sub WorldCenterUpdated (gs As X2GameStep)
'	CreateEnemies
	'move the left edge to limit the movement.
'	LeftEdge.Body.SetTransform(X2.CreateVec2(X2.ScreenAABB.BottomLeft.X,  LeftEdge.Body.Position.Y), 0)
End Sub

Public Sub DrawingComplete
	TileMap.DrawingComplete
End Sub


'must handle this event if we want to handle the PreSolve event.
Private Sub World_BeginContact (Contact As B2Contact)
	Dim bodies As X2BodiesFromContact = X2.GetBodiesFromContact(Contact, "mario")
	If bodies <> Null Then
		If bodies.OtherBody.Name = "mushroom" Then
'			'we cannot modify the world state inside these events. So we add a future task with time = 0.
'			X2.AddFutureTask(mMario, "Touch_Mushroom", 0, bodies.OtherBody)
		End If
	End If
	
	Dim bodies As X2BodiesFromContact = X2.GetBodiesFromContact(Contact, "left edge")
'	If bodies <> Null And bodies.OtherBody.DelegateTo Is Enemy Then
'		X2.AddFutureTask(Me, "Delete_Enemy", 0, bodies.OtherBody)
'		Return
'	End If
	
End Sub

Private Sub World_PreSolve (Contact As B2Contact, OldManifold As B2Manifold)
	Dim BodyA As X2BodyWrapper = Contact.FixtureA.Body.Tag
	Dim BodyB As X2BodyWrapper = Contact.FixtureB.Body.Tag
	If BodyA.IsVisible = False Or BodyB.IsVisible = False Then Return
	CheckMarioCollisions (Contact, X2.GetBodiesFromContact(Contact, "mario"))
'	CheckEnemyCollisions(Contact, X2.GetBodiesFromContact(Contact, "enemy bug"))
'	CheckEnemyCollisions(Contact, X2.GetBodiesFromContact(Contact, "enemy turtle"))
End Sub



Private Sub CheckMarioCollisions (Contact As B2Contact, bodies As X2BodiesFromContact)
	If bodies = Null Then Return
	'check the normal between the kid and other bodies. If the Y value is negative then the kid is standing on something.
	Dim wm As B2WorldManifold
	Contact.GetWorldManifold(wm)
	wm.Normal.MultiplyThis(bodies.NormalSign)
	If wm.Normal.Y < -0.5 Then
		mMario.InAir = False
	End If
'	If bodies.OtherBody.DelegateTo Is Enemy Then
'		Dim Other As Enemy = bodies.OtherBody.DelegateTo
'		If Other.HitState Then Return
'		If wm.Normal.Y < -0.5 Then
'			'hit enemy from above
'			X2.AddFutureTask(bodies.OtherBody.DelegateTo, "HitFromMario_Start", 0, Null)
'			If mMario.IsLegsFixture(bodies.ThisFixture) Then
'				'give mario a small push
'				mMario.bw.Body.ApplyLinearImpulse(X2.CreateVec2(0, 20 * mMario.bw.Body.Mass), mMario.bw.Body.WorldCenter)
'			End If
'		Else
'			'hit enemy from the side
'			X2.AddFutureTask(mMario, "Hit_Start", 0, Null)
'		End If
'	End If
End Sub


'Return True to stop the game loop
Public Sub BeforeTimeStep (GS As X2GameStep) As Boolean
'	mMario.InAir = True
	If GameOverState Then
		Return True
	End If
	Return False
End Sub

Private Sub HandleKeys (GS As X2GameStep)
	Dim v As B2Vec2 = X2.ScreenAABB.Center
	Dim delta As Float = X2.TimeStepMs / 300
	If RightDown Then
		v.X = v.X + delta
	Else If LeftDown Then
		v.X = v.X - delta
	End If
	If JumpDown Then
		v.Y = v.y + delta
	Else If DownDown Then
		v.y = v.y - delta
	End If
	If v.Equals(X2.ScreenAABB.Center) = False Then
		X2.UpdateWorldCenter(v)
	End If
End Sub


Sub pnlTouch_Touch (Action As Int, X As Float, Y As Float)
	If Action = pnlTouch.TOUCH_ACTION_DOWN Or Action = pnlTouch.TOUCH_ACTION_MOVE Then
		LeftDown = x < pnlTouch.Width / 3
		RightDown = x > 2 / 3 * pnlTouch.Width
		JumpDown = y < pnlTouch.Height / 3
		DownDown = y > 2 / 3 * pnlTouch.Height
	Else If Action = pnlTouch.TOUCH_ACTION_UP Then
		RightDown = False
		LeftDown = False
		JumpDown = False
		DownDown = False
	End If
End Sub

